SystemOrganization addCategory: #'DAO-TP-Changes'!

TestCase subclass: #ChangesTest
	instanceVariableNames: 'diccionarioDeAcciones nombreDelAutor fechaYHoraTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangesTest class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 00:06'!
mensajeTest
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:37'!
algunaUnidadDeTrabajo
	^UnidadDeTrabajoInicial  new.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:00'!
autorTest
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:06'!
cambio01
	^1.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:42'!
classAdded: aClass inCategory: aCategoryName 
	(diccionarioDeAcciones at: ClassAdded) value: (ClassAdded class: aClass category: aCategoryName).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 13:02'!
classCategoryAdded: unNombreDeCategoria 
	(diccionarioDeAcciones at: CategoryAdded) value: (CategoryAdded categoryName: unNombreDeCategoria).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:01'!
classCategoryRenamedFrom: anOldClassCategoryName to: aNewClassCategoryName
	(diccionarioDeAcciones at: CategoryRenamed ) value: (CategoryRenamed classCategoryRenamedFrom: anOldClassCategoryName to: aNewClassCategoryName).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 00:38'!
classDefinitionChangedFrom: aBlahClass to: aBlahClass2 
	(diccionarioDeAcciones at: ClassModifiedClassDefinition) value:  (ClassModifiedClassDefinition classDefinitionChangedFrom: aBlahClass to: aBlahClass2)! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 03:16'!
classRemoved: aClass fromCategory: aCategoryName
	( diccionarioDeAcciones at: ClassRemoved ) value: (ClassRemoved class: aClass category: aCategoryName).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 18:48'!
fullName
	^nombreDelAutor.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:06'!
fullName: unNombreDelAutor 
	nombreDelAutor := unNombreDelAutor.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:37'!
initialize 
	diccionarioDeAcciones := Dictionary new.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 23:40'!
methodAdded: aMethod selector: aSymbol inProtocol: aCategoryName class: aClass requestor: requestor
	(diccionarioDeAcciones at: MethodAdded ) value: (MethodAdded method: aMethod selector: aSymbol protocol: aCategoryName class: aClass requestor: requestor).
	
	
! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:10'!
now
	^fechaYHoraTest.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:41'!
on: unTipoDeEvento do: aBlockClosure 
	
	diccionarioDeAcciones at: unTipoDeEvento put: aBlockClosure.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:00'!
relojTest
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/30/2013 01:53'!
selector: aSelector recategorizedFrom: aNewProtocol to: anOldProtocol inClass: aClass 
	(diccionarioDeAcciones at: MethodRecategorized) value: (MethodRecategorized method: (aClass compiledMethodAt: aSelector ifAbsent: [nil]) selector: aSelector class: aClass newProtocol: anOldProtocol oldProtocol: aNewProtocol  ).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:08'!
setear: aDateAndTime 
	fechaYHoraTest := aDateAndTime.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 9/16/2013 22:55'!
test001LaUnidadDeTrabajoInicialNoSabeResponderElMensajePadre
	| unaUnidadDeTrabajoInicial |
	unaUnidadDeTrabajoInicial := UnidadDeTrabajoInicial new.
	self should: [ unaUnidadDeTrabajoInicial padre ]
			raise:  MessageNotUnderstood 
			withExceptionDo: [ :aMessageNotUnderstood  | aMessageNotUnderstood messageText = '#padre' ]
! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'maxi 9/23/2013 19:07'!
test002UnaUnidadDeTrabajoSeCreaSinCambiosYAbierta
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajoReal newWith: self algunaUnidadDeTrabajo.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty.
	self deny: unaUnidadDeTrabajo estaCerrada.
	
	unaUnidadDeTrabajo := UnidadDeTrabajoInicial new.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty.
	self deny: unaUnidadDeTrabajo estaCerrada.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastinGarbi 9/30/2013 01:25'!
test003UnaUnidadDeTrabajoQueRegistraUnCambioNoEstaVacia
	
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajoReal newWith: self algunaUnidadDeTrabajo.
	unaUnidadDeTrabajo registrarCambio: self cambio01.
	self deny: unaUnidadDeTrabajo todosLosCambios isEmpty.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastinGarbi 9/30/2013 01:25'!
test004RegistrarUnCambioEnUnidadCerradaLanzaUnaExcepcion
	
	| unaUnidadDeTrabajo |
	
	unaUnidadDeTrabajo := UnidadDeTrabajoReal newWith: self algunaUnidadDeTrabajo .
	unaUnidadDeTrabajo cerrar.

	self should: [ unaUnidadDeTrabajo registrarCambio: self cambio01 ] raise: Error withExceptionDo:  [ :anError | anError messageText  = UnidadDeTrabajoReal noSePuedeRegistrarCambios.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty ].

	! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 18:53'!
test005UnSistemaDeCambiosSeInicializaConUnaUnidadDeTrabajoActivaVacia
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios new.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: unSistemaDeCambios unidadActiva todosLosCambios size = 0.! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 18:55'!
test006ElSistemaRegistraElCambioEnLaUnidadActiva
	
	| unSistemaDeCambios unaUnidadDeTrabajo |

	unSistemaDeCambios := SistemaDeCambios new.
	
	unSistemaDeCambios registrarCambio: self cambio01.
	unaUnidadDeTrabajo := unSistemaDeCambios unidadActiva. 

	self assert: unaUnidadDeTrabajo todosLosCambios size = 1.
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 18:55'!
test007ElSistemaAlCerrarLaUnidadActivaNoCreaUnaUnidadNueva
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios new.
	
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	
	self assert: unSistemaDeCambios unidadActiva estaCerrada .
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 9/16/2013 22:54'!
test007UnaunidadDeTrabajoRealConoceASuPadre
	| unaUnidadDeTrabajoPadre unaUnidadDeTrabajo |
	unaUnidadDeTrabajoPadre := self algunaUnidadDeTrabajo.
	unaUnidadDeTrabajo  := UnidadDeTrabajoReal newWith: unaUnidadDeTrabajoPadre.
	self assert: (unaUnidadDeTrabajo padre = unaUnidadDeTrabajoPadre).! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 18:55'!
test008ElSistemaAlCerrarLaUnidadActivaSoloTieneUnidadesDeTrabajoCerradas
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios new.
	
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: ( unSistemaDeCambios unidadesDeTrabajo allSatisfy: [ :unaUnidadDeTrabajo | unaUnidadDeTrabajo estaCerrada ] ).! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/30/2013 01:31'!
test010ElSistemaDebeCrearUnaUnidadCuandoLaActualEsteCerradaYSeRegistreUnCambio
	| unSistemaDeCambios unaInterfaceDeEventosDeEntrada unCambio |

	unaInterfaceDeEventosDeEntrada:= self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
			
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	unCambio := CreatedClassChange newAffectedClassName: 'ChangesTest' categoryName: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unCambio.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 2.
	self assert: unSistemaDeCambios todosLosCambios size = 1! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/30/2013 01:31'!
test011UnCambioDebeSaberEnQueMomentoFueRealizadoYPorQuien
	
	| unSistemaDeCambios unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := CreatedClassChange newAffectedClassName: 'ChangesTest' categoryName: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.

	self assert: ( unSistemaDeCambios todosLosCambios allSatisfy: [ :unRegistroDeCambio | (((unRegistroDeCambio autor = self autorTest fullName ) 
																								and: unRegistroDeCambio fechaYHora = self relojTest now) 
																								and: unRegistroDeCambio cambio affectedClassName = 'ChangesTest')
																								and:  unRegistroDeCambio cambio categoryName = 'DAO-TP-Changes'] ).
	! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/30/2013 01:31'!
test012ElSistemaRegistraLosCambiosDeTipoClassRemoved
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ClassRemovedChange newAffectedClassName: 'ChangesTest' categoryName: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	self assert: ( unSistemaDeCambios todosLosCambios allSatisfy: [ :unRegistroDeCambio | (((unRegistroDeCambio autor = self autorTest fullName ) 
																								and: unRegistroDeCambio fechaYHora = self relojTest now) 
																								and: unRegistroDeCambio cambio affectedClassName = 'ChangesTest')
																								and:  unRegistroDeCambio cambio categoryName = 'DAO-TP-Changes'] ).! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/30/2013 01:16'!
test013ElSistemaRegistraLosCambiosDeTipoClassRecategorized
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ClassRecategorizedChange classAffected: 'ChangesTest' from: 'DAO-TP-Changes-old' to: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTest').
		self assert: (unRegistroDeCambio cambio oldCategoryName = 'DAO-TP-Changes-old').
		self assert: (unRegistroDeCambio cambio newCategoryName = 'DAO-TP-Changes').
		]! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/30/2013 01:18'!
test014ElSistemaRegistraLosCambiosDeTipoClassMethodCreated
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ClassMethodCreatedChange onClass: 'ChangesTestClass' selector: 'nombreDelMetodo' protocol: 'as yet unclassified' sourceCode: '^self'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTestClass').
		self assert: (unRegistroDeCambio cambio selector = 'nombreDelMetodo').
		self assert: (unRegistroDeCambio cambio protocol = 'as yet unclassified').
		self assert: (unRegistroDeCambio cambio sourceCode = '^self').	
		]! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/30/2013 01:18'!
test015ElSistemaRegistraLosCambiosDeTipoClassMethodRemoved
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ClassMethodRemovedChange onClass: 'ChangesTestClass' selector: 'nombreDelMetodo' protocol: 'as yet unclassified' sourceCode: '^self'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTestClass').
		self assert: (unRegistroDeCambio cambio selector = 'nombreDelMetodo').
		self assert: (unRegistroDeCambio cambio protocol = 'as yet unclassified').
		self assert: (unRegistroDeCambio cambio sourceCode = '^self').	
		]! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/30/2013 01:18'!
test016ElSistemaRegistraLosCambiosDeTipoInstanceMethodCreated
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := InstanceMethodCreatedChange onClass: 'ChangesTest' selector: 'nombreDelMetodo' protocol: 'as yet unclassified' sourceCode: '^self'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTest').
		self assert: (unRegistroDeCambio cambio selector = 'nombreDelMetodo').
		self assert: (unRegistroDeCambio cambio protocol = 'as yet unclassified').
		self assert: (unRegistroDeCambio cambio sourceCode = '^self').	
		]! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/30/2013 01:18'!
test017ElSistemaRegistraLosCambiosDeTipoInstanceMethodRemoved
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ClassMethodRemovedChange onClass: 'ChangesTestClass' selector: 'nombreDelMetodo' protocol: 'as yet unclassified' sourceCode: '^self'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTestClass').
		self assert: (unRegistroDeCambio cambio selector = 'nombreDelMetodo').
		self assert: (unRegistroDeCambio cambio protocol = 'as yet unclassified').
		self assert: (unRegistroDeCambio cambio sourceCode = '^self').	
		]! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/30/2013 01:17'!
test018ElSistemaRegistraLosCambiosDeTipoClassCategoryCreated_y_ClassCategoryRemoved
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada handle: (ClassCategoryCreatedChange newName: 'DAO-TP-Changes').
	unaInterfaceDeEventosDeEntrada handle: (ClassCategoryRemovedChange newName: 'DAO-TP-Changes').
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio categoryName = 'DAO-TP-Changes').
		]! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/30/2013 01:31'!
test111ElSistemaPuedeCrearCambiosEnDistintasUnidades
 | unSistemaDeCambios unaInterfaceDeEventosDeEntrada unCambio |

 unaInterfaceDeEventosDeEntrada:= self unaInterfaceDeEventosDeEntradaInicializada.
 unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
   
 unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
 unCambio := CreatedClassChange newAffectedClassName: 'ChangesTest' categoryName: 'DAO-TP-Changes'.
 unaInterfaceDeEventosDeEntrada handle: unCambio.

 unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
 unaInterfaceDeEventosDeEntrada handle: unCambio.

 unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
 unaInterfaceDeEventosDeEntrada handle: unCambio.
 
 self assert: unSistemaDeCambios unidadesDeTrabajo size = 4.
 self assert: unSistemaDeCambios todosLosCambios size = 3.
 self assert: ( unSistemaDeCambios todosLosCambios allSatisfy: [ :unRegistroDeCambio | (((unRegistroDeCambio autor = self autorTest fullName ) 
                        and: unRegistroDeCambio fechaYHora = self relojTest now) 
                        and: unRegistroDeCambio cambio affectedClassName = 'ChangesTest')
                        and:  unRegistroDeCambio cambio categoryName = 'DAO-TP-Changes'] ).! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/29/2013 22:42'!
test900LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipoClassCreated

 | systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada |
 

 systemAnnouncerTest := self unSystemAnnouncer.
 unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
 
 InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
 
 unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
 
 systemAnnouncerTest classAdded: ChangesTest inCategory: #'DAO-TP-Changes'.
 
 unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
  self assert: (unRegistroDeCambio autor = self autorTest fullName).
  self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
  self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTest').
  self assert: (unRegistroDeCambio cambio categoryName = 'DAO-TP-Changes'). 
  ].! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/30/2013 00:10'!
test901LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipoClassMethodCreated

 | systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada unMetodo |
 

 systemAnnouncerTest := self unSystemAnnouncer.
 unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
 
 InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
 
 unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
 unMetodo :=  (self class class methodDict  at: #mensajeTest).
 systemAnnouncerTest methodAdded: unMetodo selector: unMetodo selector inProtocol: 'as yet unclassified' class: unMetodo methodClass requestor: nil.

 unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
	self assert: (unRegistroDeCambio autor = self autorTest fullName).
	self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
	self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTest class').
	self assert: (unRegistroDeCambio cambio selector = unMetodo selector).
	self assert: (unRegistroDeCambio cambio protocol = 'as yet unclassified').
	self assert: (unRegistroDeCambio cambio sourceCode = unMetodo decompile printString) .	
  ].! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/30/2013 00:16'!
test902LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipoInstanceMethodCreated

 | systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada unMetodo |
 

 systemAnnouncerTest := self unSystemAnnouncer.
 unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
 
 InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
 
 unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
 unMetodo :=  (self class methodDict  at: #now).
 systemAnnouncerTest methodAdded: unMetodo selector: unMetodo selector inProtocol: 'as yet unclassified' class: unMetodo methodClass requestor: nil.

 unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
	self assert: (unRegistroDeCambio autor = self autorTest fullName).
	self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
	self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTest').
	self assert: (unRegistroDeCambio cambio selector = unMetodo selector).
	self assert: (unRegistroDeCambio cambio protocol = 'as yet unclassified').
	self assert: (unRegistroDeCambio cambio sourceCode = unMetodo decompile printString) .	
  ].! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/30/2013 00:54'!
test903LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipoSuperclassChanged
 | systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada unaClase otraClase |
 

	systemAnnouncerTest := self unSystemAnnouncer.
	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
 
	InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
 
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.

	unaClase := (ChangesTest subclass:  #Blah category: 'DAO-TP-Changes') copy.
	otraClase := Object subclass:  #Blah category: 'DAO-TP-Changes'.

	systemAnnouncerTest  classDefinitionChangedFrom: unaClase to: otraClase.

	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = #Blah).
		self assert: (unRegistroDeCambio cambio oldSuperclassName = #ChangesTest).
		self assert: (unRegistroDeCambio cambio newSuperclassName = #Object).
  ].! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/30/2013 01:03'!
test904LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipoClassCategoryRenamed
 | systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada |
 

	systemAnnouncerTest := self unSystemAnnouncer.
	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
 
	InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
 
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.

	systemAnnouncerTest  classCategoryRenamedFrom: 'asd1' to: 'asd2'.

	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio oldCategoryName = 'asd1').
		self assert: (unRegistroDeCambio cambio newCategoryName = 'asd2').
  ].! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:11'!
tipoDelCambio01
	^'Agregar'.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:11'!
unSystemAnnouncer
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:43'!
unaInterfaceDeEventosDeEntradaInicializada
	| unAutor unReloj unSistemaDeCambios |
	unReloj := self relojTest.
	unAutor := self autorTest.
	unSistemaDeCambios := SistemaDeCambios new.
	unAutor fullName: 'Seba'.
	unReloj setear: DateAndTime now.
	^InterfaceDeEntradaDelSistemaDeCambios newWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj! !

Object subclass: #Blah
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

Object subclass: #Change
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!Change class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 21:33'!
nuevo
	self subclassResponsibility .! !

Change subclass: #ClassCategoryChange
	instanceVariableNames: 'categoryName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassCategoryChange class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:33'!
newName: unNombreDeCategoria
	^self new categoryName: unNombreDeCategoria.
	! !

!ClassCategoryChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:36'!
categoryName
	^ categoryName! !

!ClassCategoryChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:36'!
categoryName: unNombreDeCategoria
	categoryName := unNombreDeCategoria.! !

ClassCategoryChange subclass: #ClassCategoryCreatedChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

ClassCategoryChange subclass: #ClassCategoryRemovedChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

Change subclass: #ClassCategoryRenamedChange
	instanceVariableNames: 'oldCategoryName newCategoryName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassCategoryRenamedChange class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:13'!
from: oldName to: newName
	^self new oldCategoryName: oldName newCategoryName: newName.
	! !

!ClassCategoryRenamedChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:15'!
newCategoryName
	^ newCategoryName! !

!ClassCategoryRenamedChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:15'!
oldCategoryName
	^ oldCategoryName! !

!ClassCategoryRenamedChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:15'!
oldCategoryName: oldName newCategoryName: newName.
	oldCategoryName := oldName.
	newCategoryName := newName.! !

Change subclass: #ClassChange
	instanceVariableNames: 'affectedClassName categoryName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassChange class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 23:00'!
newAffectedClassName: unNombreDeClase categoryName: unNombreDeCategoria 
	^self nuevo affectedClassName: unNombreDeClase  categoryName: unNombreDeCategoria.! !

!ClassChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:43'!
affectedClassName
	^ affectedClassName! !

!ClassChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:43'!
affectedClassName: unNombreDeClase categoryName: unNombreDeCategoria 
	affectedClassName := unNombreDeClase.
	categoryName := unNombreDeCategoria.! !

!ClassChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:43'!
categoryName
	^categoryName.! !

ClassChange subclass: #ClassRemovedChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 21:33'!
nuevo
	^self new! !

ClassChange subclass: #CreatedClassChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!CreatedClassChange class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 21:33'!
nuevo
	^self new.! !

Change subclass: #ClassMethodCategoryRenamedChange
	instanceVariableNames: 'affectedClassName selector method oldCategory newCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassMethodCategoryRenamedChange class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/30/2013 01:43'!
newAffectedClassName: aClassName withThisSelector: aByteSymbol withThisMethod: aByteString fromThisCategory: aByteString4 toThisCategory: aByteString5 
	^self new initializeWithThisClassName: aClassName withThisSelector: aByteSymbol withThisMethod: aByteString fromThisCategory: aByteString4 toThisCategory: aByteString5.! !

!ClassMethodCategoryRenamedChange methodsFor: 'as yet unclassified' stamp: 'Maxii 9/30/2013 01:46'!
affectedClassName
	^ affectedClassName! !

!ClassMethodCategoryRenamedChange methodsFor: 'as yet unclassified' stamp: 'Maxii 9/30/2013 01:48'!
affectedMethodName
	^selector.! !

!ClassMethodCategoryRenamedChange methodsFor: 'as yet unclassified' stamp: 'Maxii 9/30/2013 01:47'!
initializeWithThisClassName: aByteSymbol withThisSelector: aByteSymbol2 withThisMethod: aByteString fromThisCategory: aByteString4 toThisCategory: aByteString5 
	affectedClassName := aByteSymbol.
	selector := aByteSymbol2.
	method := aByteString .
	oldCategory := aByteString4 .
	newCategory := aByteString5 .! !

!ClassMethodCategoryRenamedChange methodsFor: 'as yet unclassified' stamp: 'Maxii 9/30/2013 01:54'!
newCategoryName
	^newCategory.! !

!ClassMethodCategoryRenamedChange methodsFor: 'as yet unclassified' stamp: 'Maxii 9/30/2013 01:49'!
oldCategoryName
	^oldCategory.! !

Change subclass: #ClassRecategorizedChange
	instanceVariableNames: 'affectedClassName newCategoryName oldCategoryName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassRecategorizedChange class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:46'!
classAffected: unNombreDeClase from: unNombreDeCategoriaVieja to: unNombreDeCategoriaNueva
	^self new affectedClassName: unNombreDeClase fromCategory: unNombreDeCategoriaVieja toCategory: unNombreDeCategoriaNueva.
	! !

!ClassRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:44'!
affectedClassName
	^ affectedClassName! !

!ClassRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:46'!
affectedClassName: unNombreDeClase fromCategory: unNombreDeCategoriaVieja toCategory: unNombreDeCategoriaNueva.
	affectedClassName := unNombreDeClase.
	oldCategoryName := unNombreDeCategoriaVieja.
	newCategoryName := unNombreDeCategoriaNueva.! !

!ClassRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:46'!
newCategoryName
	^ newCategoryName! !

!ClassRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:46'!
oldCategoryName
	^ oldCategoryName! !

Change subclass: #MethodChange
	instanceVariableNames: 'sourceCode affectedClassName protocol selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

MethodChange subclass: #ClassMethodChange
	instanceVariableNames: 'nombreDeClase nombreSelector nombreProtocolo codigo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

ClassMethodChange subclass: #ClassMethodCreatedChange
	instanceVariableNames: 'nombreDeClase nombreSelector nombreProtocolo codigo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassMethodCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 21:34'!
nuevo
	^self new! !

ClassMethodChange subclass: #ClassMethodRemovedChange
	instanceVariableNames: 'codigo nombreDeClase nombreSelector nombreProtocolo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassMethodRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 21:34'!
nuevo
	^self new! !

MethodChange subclass: #InstanceMethodChange
	instanceVariableNames: 'nombreDeClase nombreSelector nombreProtocolo codigo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

InstanceMethodChange subclass: #InstanceMethodCreatedChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InstanceMethodCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:13'!
nuevo
	^self new! !

InstanceMethodChange subclass: #InstanceMethodRemovedChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InstanceMethodRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:13'!
nuevo
	^self new! !

!MethodChange class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 23:58'!
onClass: unNombreDeClase selector: unNombreSelector protocol: unNombreProtocolo sourceCode: unCodigo 
	^self nuevo initializeOnClass: unNombreDeClase selector: unNombreSelector protocol: unNombreProtocolo sourceCode: unCodigo.! !

!MethodChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 23:56'!
affectedClassName
	^ affectedClassName! !

!MethodChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 23:56'!
className
	^ affectedClassName! !

!MethodChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 23:58'!
initializeOnClass: unNombreDeClase selector: unNombreSelector protocol: unNombreProtocolo sourceCode: unCodigo
	affectedClassName := unNombreDeClase.
	selector := unNombreSelector.
	protocol := unNombreProtocolo.
	sourceCode := unCodigo.! !

!MethodChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 23:56'!
protocol
	^ protocol! !

!MethodChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 23:57'!
selector
	^ selector! !

!MethodChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 23:56'!
sourceCode
	^ sourceCode! !

Change subclass: #SuperclassChangedChange
	instanceVariableNames: 'affectedClassName oldSuperclassName newSuperclassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!SuperclassChangedChange class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 00:50'!
newAffectedClassName: aByteSymbol oldSuperclassName: aByteSymbol2 newSupeclassName: aByteSymbol3 
	^self new affectedClassName: aByteSymbol oldSuperclassName: aByteSymbol2 newSupeclassName: aByteSymbol3.! !

!SuperclassChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 00:51'!
affectedClassName
	^ affectedClassName! !

!SuperclassChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 00:56'!
affectedClassName: aByteSymbol oldSuperclassName: aByteSymbol2 newSupeclassName: aByteSymbol3 
	affectedClassName := aByteSymbol.
	oldSuperclassName := aByteSymbol2.
	newSuperclassName := aByteSymbol3.! !

!SuperclassChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 00:55'!
newSuperclassName
	^newSuperclassName! !

!SuperclassChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 00:55'!
oldSuperclassName
	^oldSuperclassName! !

Object subclass: #InterfaceDeEntradaDelSistemaDeCambios
	instanceVariableNames: 'sistemaDeCambios autor reloj'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InterfaceDeEntradaDelSistemaDeCambios class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:22'!
newWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj 
	^self new initializeWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj.! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:52'!
agregarCambio: unCambio por: unNombreDeAutor enElMomento: unaFechaYHora 

	sistemaDeCambios registrarCambio: (RegistroDeCambio newWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora ).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:01'!
handle: unCambio 
	self agregarCambio: unCambio por: autor fullName enElMomento: reloj now.! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:22'!
initializeWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj
	sistemaDeCambios := unSistemaDeCambios.
	autor := unAutor.
	reloj := unReloj.! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:39'!
sistemaDeCambios
	^ sistemaDeCambios! !

Object subclass: #InterfazParaLosAnuncios
	instanceVariableNames: 'systemAnnouncer interfazDeEntradaDelSistemaDeCambios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InterfazParaLosAnuncios class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:48'!
newWith: anAnnouncer and: anInterfaceDeEntradaDelSistemaDeCambios 
	^self new initializeWith: anAnnouncer and: anInterfaceDeEntradaDelSistemaDeCambios.! !

!InterfazParaLosAnuncios methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 02:11'!
initializeWith: anAnnouncer and: unaInterfaceDeEntradaDelSistemaDeCambios 
	systemAnnouncer := anAnnouncer.
	interfazDeEntradaDelSistemaDeCambios := unaInterfaceDeEntradaDelSistemaDeCambios.

	systemAnnouncer on: ClassAdded  do: [ :unEvento | interfazDeEntradaDelSistemaDeCambios handle: (CreatedClassChange newAffectedClassName: unEvento classAdded name categoryName: unEvento classCategory )].
	
	systemAnnouncer on: MethodAdded  do: [ :unEvento | 
		(unEvento methodClass isKindOf: Metaclass)"Es un metodo de clase"
			ifTrue: [ interfazDeEntradaDelSistemaDeCambios handle: (ClassMethodCreatedChange onClass: unEvento methodClass name selector: unEvento selector protocol: unEvento protocol sourceCode: unEvento method decompile printString )]
			ifFalse: [ interfazDeEntradaDelSistemaDeCambios handle: (InstanceMethodCreatedChange  onClass: unEvento methodClass name selector: unEvento selector protocol: unEvento protocol sourceCode: unEvento method decompile printString )].
		].
	
	systemAnnouncer on: ClassModifiedClassDefinition do: [ :unEvento | interfazDeEntradaDelSistemaDeCambios handle: (SuperclassChangedChange newAffectedClassName: unEvento newClassDefinition name oldSuperclassName: unEvento oldClassDefinition superclass name newSupeclassName: unEvento newClassDefinition superclass name)].
	
	systemAnnouncer on: CategoryRenamed do: [ :unEvento | interfazDeEntradaDelSistemaDeCambios handle: (ClassCategoryRenamedChange from: unEvento oldCategoryName to: unEvento newCategoryName )].
	
	systemAnnouncer on: MethodRecategorized do: [  :unEvento | interfazDeEntradaDelSistemaDeCambios handle: 
		( ClassMethodCategoryRenamedChange newAffectedClassName: unEvento methodClass name withThisSelector: unEvento selector withThisMethod: unEvento methodRecategorized decompile printString fromThisCategory: unEvento oldProtocol toThisCategory: unEvento newProtocol ) ].! !

Object subclass: #RegistroDeCambio
	instanceVariableNames: 'cambio autor fechaYHora'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!RegistroDeCambio class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:54'!
newWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora 
	^self new initializeWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora.! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:56'!
autor
	^ autor! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 18:04'!
cambio
	^ cambio! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:56'!
fechaYHora
	^ fechaYHora! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:58'!
initializeWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora 
	cambio := unCambio.
	autor := unNombreDeAutor.
	fechaYHora := unaFechaYHora.! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:18'!
tipoDeCambio
	^'classRemoved'.! !

Object subclass: #SistemaDeCambios
	instanceVariableNames: 'unidadesDeTrabajoCerradas unidadDeTrabajoActiva'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/24/2013 21:53'!
cerrarUnidadDeTrabajoActiva
	self unidadActiva cerrar.
	^self! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:26'!
initialize 
	unidadesDeTrabajoCerradas := OrderedCollection new.
	unidadDeTrabajoActiva := UnidadDeTrabajoInicial new.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 21:12'!
registrarCambio: unCambio
	| nuevaUnidadActiva |
	
	[ unidadDeTrabajoActiva registrarCambio: unCambio]
		on: UnidadDeTrabajoException
		do: [ nuevaUnidadActiva := UnidadDeTrabajoReal newWith: unidadDeTrabajoActiva.
		unidadesDeTrabajoCerradas  add: unidadDeTrabajoActiva.
		unidadDeTrabajoActiva := nuevaUnidadActiva.
		unidadDeTrabajoActiva registrarCambio: unCambio ].
! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:10'!
todosLosCambios
	^self unidadActiva todosLosCambios.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/16/2013 21:41'!
unidadActiva
	"devuelve la unidad de trabajo activa"
	^unidadDeTrabajoActiva.
	! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 20:43'!
unidadesDeTrabajo
	|todasLasUnidadesDeTrabajo|
	todasLasUnidadesDeTrabajo := unidadesDeTrabajoCerradas asSet.
	todasLasUnidadesDeTrabajo add: unidadDeTrabajoActiva.
	^todasLasUnidadesDeTrabajo.! !

Object subclass: #UnidadDeTrabajo
	instanceVariableNames: 'cambios cerrada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

UnidadDeTrabajo class
	instanceVariableNames: 'unidadActiva unidadesCerradas'!

UnidadDeTrabajo class
	instanceVariableNames: 'unidadActiva unidadesCerradas'!

!UnidadDeTrabajo class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
noSePuedeRegistrarCambios
	^'No se puede registrar cambios en esta unidad de trabajo.'.! !

!UnidadDeTrabajo class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 23:30'!
registrarCambio: unCambio
	| nuevaUnidadActiva |
	[ unidadActiva registrarCambio: unCambio]
	on: Error
	do: [ nuevaUnidadActiva := UnidadDeTrabajoReal newWith: unidadActiva.
		unidadesCerradas add: unidadActiva.
		unidadActiva := nuevaUnidadActiva.
		unidadActiva registrarCambio: unCambio ].
	^self
! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
cerrar
	cerrada := true.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
estaCerrada
	^cerrada.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
initialize
	cambios := OrderedCollection new.
	cerrada := false.
	^self! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 15:29'!
registrarCambio: unCambio
	self estaCerrada ifTrue: [ UnidadDeTrabajoException  signal: self class noSePuedeRegistrarCambios]. 
	cambios add: unCambio.
	^self.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:21'!
todosLosCambios
	self subclassResponsibility.! !

UnidadDeTrabajo subclass: #UnidadDeTrabajoInicial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!UnidadDeTrabajoInicial methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:22'!
todosLosCambios 
	^cambios copy.! !

UnidadDeTrabajo subclass: #UnidadDeTrabajoReal
	instanceVariableNames: 'padre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!UnidadDeTrabajoReal class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:38'!
newWith: unaUnidadDeTrabajo
	^self new initializeWith: unaUnidadDeTrabajo.! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:39'!
initializeWith: unaUnidadDeTrabajo
	padre := unaUnidadDeTrabajo.
	^self.
	! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:53'!
padre
	^ padre! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:45'!
todosLosCambios 
	^self padre todosLosCambios addAll: cambios;yourself.! !

Error subclass: #UnidadDeTrabajoException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!
